#property link      "ALXIMIKS"
#property version   "1.00"
#property strict

#property indicator_separate_window
#property indicator_buffers 4

#property indicator_color4   clrGreen
#property indicator_color3   clrRed
#property indicator_color2   clrGray
#property indicator_color1   clrGray

#property indicator_width4   4
#property indicator_width3   4
#property indicator_width2   1
#property indicator_width1   1

extern int count_bars = 3000;       

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
   IndicatorDigits(Digits);
      
   SetIndexBuffer(3, buffer1);
   SetIndexBuffer(2, buffer2);
   SetIndexBuffer(1, buffer3);
   SetIndexBuffer(0, buffer4);

   for (int i = 3; i>=0; --i)
   {
      SetIndexStyle(i, DRAW_HISTOGRAM);
      SetIndexEmptyValue(i, 0);
      SetIndexLabel(i, NULL);
   }   
   
   SetLevelStyle(DRAW_LINE, 1, clrWhite);
   SetLevelValue(0, 0);
   
   return(INIT_SUCCEEDED);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int limit;                                    // number of bars for calculate
   
   if (prev_calculated == 0)                     // firts run or was loaded some number of burs
   {
   
//--- clear Buffers
      ArrayInitialize(buffer1, 0);
      ArrayInitialize(buffer2, 0);
      ArrayInitialize(buffer3, 0);
      ArrayInitialize(buffer4, 0);
      
//--- get number of bars for calculate      
      limit = MathMin(count_bars, rates_total - 1);
   }
   else
      limit = rates_total - prev_calculated;
    

   double open_val;                        
   double close_open_diff;
    
   for (int i = limit; i>=0; --i)
   {
      if ((close_open_diff = close[i] - (open_val = open[i])) > 0)    // close > open ???
      {
         buffer1[i] = close_open_diff;
         buffer2[i] = 0;
         buffer3[i] = high[i] - open_val;
         buffer4[i] = low[i] - open_val;
      }
      else                                                            // close <= open
      {
         buffer1[i] = 0;
         buffer2[i] = close_open_diff;
         buffer3[i] = low[i] - open_val;
         buffer4[i] = high[i] - open_val;
      }
   
   }
   return(rates_total);
}
//+------------------------------------------------------------------+
